/*!
[config]
name: Test uchar rhadd built-in on CL 1.1
clc_version_min: 10
dimensions: 1
global_size: 1 0 0

[test]
name: rhadd uchar1
kernel_name: test_1_rhadd_uchar
arg_out: 0 buffer uchar[1] 33
arg_in: 1 buffer uchar[1] 32
arg_in: 2 buffer uchar[1] 33

[test]
name: rhadd uchar1
kernel_name: test_1_rhadd_uchar
arg_out: 0 buffer uchar[1] 1
arg_in: 1 buffer uchar[1] 1
arg_in: 2 buffer uchar[1] 0

[test]
name: rhadd uchar1
kernel_name: test_1_rhadd_uchar
arg_out: 0 buffer uchar[1] 10
arg_in: 1 buffer uchar[1] 12
arg_in: 2 buffer uchar[1] 8

[test]
name: rhadd uchar2
kernel_name: test_2_rhadd_uchar
arg_out: 0 buffer uchar[2] 33 33
arg_in: 1 buffer uchar[2] 32 32
arg_in: 2 buffer uchar[2] 33 33

[test]
name: rhadd uchar2
kernel_name: test_2_rhadd_uchar
arg_out: 0 buffer uchar[2] 1 1
arg_in: 1 buffer uchar[2] 1 1
arg_in: 2 buffer uchar[2] 0 0

[test]
name: rhadd uchar2
kernel_name: test_2_rhadd_uchar
arg_out: 0 buffer uchar[2] 10 10
arg_in: 1 buffer uchar[2] 12 12
arg_in: 2 buffer uchar[2] 8 8

[test]
name: rhadd uchar4
kernel_name: test_4_rhadd_uchar
arg_out: 0 buffer uchar[4] 33 33 33 33
arg_in: 1 buffer uchar[4] 32 32 32 32
arg_in: 2 buffer uchar[4] 33 33 33 33

[test]
name: rhadd uchar4
kernel_name: test_4_rhadd_uchar
arg_out: 0 buffer uchar[4] 1 1 1 1
arg_in: 1 buffer uchar[4] 1 1 1 1
arg_in: 2 buffer uchar[4] 0 0 0 0

[test]
name: rhadd uchar4
kernel_name: test_4_rhadd_uchar
arg_out: 0 buffer uchar[4] 10 10 10 10
arg_in: 1 buffer uchar[4] 12 12 12 12
arg_in: 2 buffer uchar[4] 8 8 8 8

[test]
name: rhadd uchar8
kernel_name: test_8_rhadd_uchar
arg_out: 0 buffer uchar[8] 33 33 33 33 33 33 33 33
arg_in: 1 buffer uchar[8] 32 32 32 32 32 32 32 32
arg_in: 2 buffer uchar[8] 33 33 33 33 33 33 33 33

[test]
name: rhadd uchar8
kernel_name: test_8_rhadd_uchar
arg_out: 0 buffer uchar[8] 1 1 1 1 1 1 1 1
arg_in: 1 buffer uchar[8] 1 1 1 1 1 1 1 1
arg_in: 2 buffer uchar[8] 0 0 0 0 0 0 0 0

[test]
name: rhadd uchar8
kernel_name: test_8_rhadd_uchar
arg_out: 0 buffer uchar[8] 10 10 10 10 10 10 10 10
arg_in: 1 buffer uchar[8] 12 12 12 12 12 12 12 12
arg_in: 2 buffer uchar[8] 8 8 8 8 8 8 8 8

[test]
name: rhadd uchar16
kernel_name: test_16_rhadd_uchar
arg_out: 0 buffer uchar[16] 33 33 33 33 33 33 33 33 33 33 33 33 33 33 33 33
arg_in: 1 buffer uchar[16] 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
arg_in: 2 buffer uchar[16] 33 33 33 33 33 33 33 33 33 33 33 33 33 33 33 33

[test]
name: rhadd uchar16
kernel_name: test_16_rhadd_uchar
arg_out: 0 buffer uchar[16] 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
arg_in: 1 buffer uchar[16] 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
arg_in: 2 buffer uchar[16] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0

[test]
name: rhadd uchar16
kernel_name: test_16_rhadd_uchar
arg_out: 0 buffer uchar[16] 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10
arg_in: 1 buffer uchar[16] 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12
arg_in: 2 buffer uchar[16] 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8

!*/

kernel void test_1_rhadd_uchar(global uchar* out, global uchar* in0, global uchar* in1){
  *out = rhadd(*in0, *in1);
}

kernel void test_2_rhadd_uchar(global uchar* out, global uchar* in0, global uchar* in1){
  vstore2(rhadd(vload2(0, in0), vload2(0, in1)), 0, out);
}

kernel void test_4_rhadd_uchar(global uchar* out, global uchar* in0, global uchar* in1){
  vstore4(rhadd(vload4(0, in0), vload4(0, in1)), 0, out);
}

kernel void test_8_rhadd_uchar(global uchar* out, global uchar* in0, global uchar* in1){
  vstore8(rhadd(vload8(0, in0), vload8(0, in1)), 0, out);
}

kernel void test_16_rhadd_uchar(global uchar* out, global uchar* in0, global uchar* in1){
  vstore16(rhadd(vload16(0, in0), vload16(0, in1)), 0, out);
}

